/* Problem URL: https://codeforces.com/contest/450/problem/B */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

void solve()
{
    ll x, y, n;
    cin >> x >> y >> n;

    const ll mod = 1e9 + 7;

    if (n == 1) {
        cout << x + mod * (x < 0) << '\n';
        return;
    }

    if (n == 2) {
        cout << y + mod * (y < 0) << '\n';
        return;
    }
    n -= 2;

    auto mul = [&](vvl &a, vvl &b) {
        vvl c(a.size(), vl(b[0].size()));

        rep(i, c.size()) {
            rep(j, c[0].size()) {
                rep(k, b.size()) {
                    c[i][j] = ((c[i][j] + a[i][k] * b[k][j] % mod) % mod + mod) % mod;
                }
            }
        }

        return c;
    };

    auto fpow = [&]() {
        vvl ans = {{x}, {y}};
        vvl mu(2, vl(2));
        mu[0][1] = 1;
        mu[1][0] = mod - 1;
        mu[1][1] = 1;

        rep(i, 31) {
            if ((n >> i) & 1) {
                ans = mul(mu, ans);
            }

            mu = mul(mu, mu);
        }

        return ans;
    };

    auto ans = fpow();

    cout << ans[1][0] << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
